QCPItemBracket Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Public Members | Protected Types | Protected Functions
QCPItemBracket Class Reference

A bracket for referencing/highlighting certain parts in the plot. More...

Inheritance diagram for QCPItemBracket:

## Public Types
enum | BracketStyle

## Public Functions
| QCPItemBracket (QCustomPlot *parentPlot)
QPen | pen () const
QPen | selectedPen () const
double | length () const
BracketStyle | style () const
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
void | setLength (double length)
void | setStyle (BracketStyle style)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const
Public Functions inherited from QCPAbstractItem
| QCPAbstractItem (QCustomPlot *parentPlot)
bool | clipToAxisRect () const
QCPAxisRect * | clipAxisRect () const
bool | selectable () const
bool | selected () const
void | setClipToAxisRect (bool clip)
void | setClipAxisRect (QCPAxisRect *rect)
Q_SLOT void | setSelectable (bool selectable)
Q_SLOT void | setSelected (bool selected)
QList< QCPItemPosition * > | positions () const
QList< QCPItemAnchor * > | anchors () const
QCPItemPosition * | position (const QString &name) const
QCPItemAnchor * | anchor (const QString &name) const
bool | hasAnchor (const QString &name) const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=nullptr)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Public Members
QCPItemPosition *const | left
QCPItemPosition *const | right
QCPItemAnchor *const | center

## Protected Types
enum | AnchorIndex

## Protected Functions
virtual void | draw (QCPPainter *painter)
virtual QPointF | anchorPixelPosition (int anchorId) const
QPen | mainPen () const
Protected Functions inherited from QCPAbstractItem
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
double | rectDistance (const QRectF &rect, const QPointF &pos, bool filledRect) const
QCPItemPosition * | createPosition (const QString &name)
QCPItemAnchor * | createAnchor (const QString &name, int anchorId)
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
virtual void | mousePressEvent (QMouseEvent *event, const QVariant &details)
virtual void | mouseMoveEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseReleaseEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseDoubleClickEvent (QMouseEvent *event, const QVariant &details)
virtual void | wheelEvent (QWheelEvent *event)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Additional Inherited Members
Signals inherited from QCPAbstractItem
void | selectionChanged (bool selected)
void | selectableChanged (bool selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Detailed Description

A bracket for referencing/highlighting certain parts in the plot.

Bracket example. Blue dotted circles are anchors, solid blue discs are positions.

It has two positions, left and right, which define the span of the bracket. If left is actually farther to the left than right, the bracket is opened to the bottom, as shown in the example image.

The bracket supports multiple styles via setStyle. The length, i.e. how far the bracket stretches away from the embraced span, can be controlled with setLength.

Demonstrating the effect of different values for setLength, for styles bsCalligraphic and bsSquare. Anchors and positions are displayed for reference.

It provides an anchor center, to allow connection of other items, e.g. an arrow (QCPItemLine or QCPItemCurve) or a text label (QCPItemText), to the bracket.

## Member Enumeration Documentation

## § BracketStyle

enum QCPItemBracket::BracketStyle

Defines the various visual shapes of the bracket item. The appearance can be further modified by setLength and setPen.

See also
  setStyle

Enumerator
bsSquare | A brace with angled edges.
bsRound | A brace with round edges.
bsCurly | A curly brace.
bsCalligraphic | A curly brace with varying stroke width giving a calligraphic impression.

## Constructor & Destructor Documentation

## § QCPItemBracket()

QCPItemBracket::QCPItemBracket | ( | QCustomPlot * | parentPlot | ) |
| explicit

Creates a bracket item and sets default values.

The created item is automatically registered with parentPlot. This QCustomPlot instance takes ownership of the item, so do not delete it manually but use QCustomPlot::removeItem() instead.

## Member Function Documentation

## § setPen()

void QCPItemBracket::setPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the bracket.

Note that when the style is bsCalligraphic, only the color will be taken from the pen, the stroke and width are ignored. To change the apparent stroke width of a calligraphic bracket, use setLength, which has a similar effect.

See also
  setSelectedPen

## § setSelectedPen()

void QCPItemBracket::setSelectedPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the bracket when selected

See also
  setPen, setSelected

## § setLength()

void QCPItemBracket::setLength | ( | double | length | ) |

Sets the length in pixels how far the bracket extends in the direction towards the embraced span of the bracket (i.e. perpendicular to the left-right-direction)

Demonstrating the effect of different values for setLength, for styles bsCalligraphic and bsSquare. Anchors and positions are displayed for reference.

## § setStyle()

void QCPItemBracket::setStyle | ( | QCPItemBracket::BracketStyle | style | ) |

Sets the style of the bracket, i.e. the shape/visual appearance.

See also
  setPen

## § selectTest()

double QCPItemBracket::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `nullptr`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the object is represented not by single lines but by an area like a QCPItemText or the bars of a QCPBars plottable, a click inside the area should also be considered a hit. In these cases this function thus returns a constant value greater zero but still below the parent plot's selection tolerance. (typically the selectionTolerance multiplied by 0.99).

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

In the case of 1D Plottables (QCPAbstractPlottable1D, like QCPGraph or QCPBars) details will be set to a QCPDataSelection, describing the closest data point to pos.

You may pass `nullptr` as details to indicate that you are not interested in those selection details.

See also
  selectEvent, deselectEvent, mousePressEvent, wheelEvent, QCustomPlot::setInteractions, QCPAbstractPlottable1D::selectTestRect

Implements QCPAbstractItem.

## § draw()

void QCPItemBracket::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

Draws this item with the provided painter.

The cliprect of the provided painter is set to the rect returned by clipRect before this function is called. The clipRect depends on the clipping settings defined by setClipToAxisRect and setClipAxisRect.

Implements QCPAbstractItem.

## § anchorPixelPosition()

QPointF QCPItemBracket::anchorPixelPosition | ( | int | anchorId | ) | const
| protectedvirtual

Returns the pixel position of the anchor with Id anchorId. This function must be reimplemented in item subclasses if they want to provide anchors (QCPItemAnchor).

For example, if the item has two anchors with id 0 and 1, this function takes one of these anchor ids and returns the respective pixel points of the specified anchor.

See also
  createAnchor

Reimplemented from QCPAbstractItem.

## § mainPen()

QPen QCPItemBracket::mainPen | ( |  | ) | const
| protected

Returns the pen that should be used for drawing lines. Returns mPen when the item is not selected and mSelectedPen when it is.

The documentation for this class was generated from the following files:

- src/items/item-bracket.h
- src/items/item-bracket.cpp